using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using sato.pt;
using System.Reflection;
using System.IO;


namespace WindowsApplication1
{
    public partial class frmConfig : Form
    {
        public frmConfig()
        {
            InitializeComponent();
        }

        /// <summary>
        /// FormLoad
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void frmConfig_Load(object sender, EventArgs e)
        {
            //********** COMPORT̐ݒ@**********
            for (int i = 0; i <= 9; i++)
            {
                //COMPORTݒ
                cmbRscPort.Items.Add("COM" + Convert.ToString(i));         //RS232C
            }

            //********** ۑ̃t@C擾@**********
            string fullAppName = Assembly.GetExecutingAssembly().GetName().CodeBase;
            string fullAppPath = Path.GetDirectoryName(fullAppName);
            string fileName = fullAppPath + @"\ConnectionMethodValue.xml";
            
            //ڑ@̒lۑĂt@C݂ꍇ̂ݏs
            if (System.IO.File.Exists(fileName) )
            {
                //********** XMLt@Cڑl擾@**********
                //XmlSerializerIuWFNg̍쐬
                System.Xml.Serialization.XmlSerializer serializer =
                    new System.Xml.Serialization.XmlSerializer(typeof(ConnectionMethodValue));
                //t@CJ
                System.IO.FileStream fs =
                    new System.IO.FileStream(fileName, System.IO.FileMode.Open);
                //XMLt@Cǂݍ݁AtVA
                ConnectionMethodValue cmv = (ConnectionMethodValue)serializer.Deserialize(fs);
                //
                fs.Close();

                //********** v^ڑ@̏ݒ@**********
                //ڑʂɂR{{bNXI
                switch (cmv.Connect)
                {
                    case WindowsApplication1.Constant.PT_CONNECT_RS232C:
                        cmbSelect.SelectedIndex = 0;
                        break;
                    case WindowsApplication1.Constant.PT_CONNECT_LAN:
                        cmbSelect.SelectedIndex = 1;
                        break;
                }
                    
                //********** RS232C̐ڑl̏ݒ@**********
                //|[g
                cmbRscPort.SelectedValue = cmv.RscPort;
                for (int i = 0; i < cmbRscPort.Items.Count; i++)
                {
                    if(cmbRscPort.Items[i].Equals(cmv.RscPort))
                    {
                        cmbRscPort.SelectedIndex = i;
                    }
                }
                //{[[g
                switch (cmv.RscBaudrate)
                {
                    case Def.BAUDRATE_9600:
                        cmbRscBaudrate.SelectedIndex = 0;
                        break;
                    case Def.BAUDRATE_19200:
                        cmbRscBaudrate.SelectedIndex = 1;
                        break;
                    case Def.BAUDRATE_38400:
                        cmbRscBaudrate.SelectedIndex = 2;
                        break;
                    case Def.BAUDRATE_57600:
                        cmbRscBaudrate.SelectedIndex = 3;
                        break;
                    case Def.BAUDRATE_115200:
                        cmbRscBaudrate.SelectedIndex = 4;
                        break;
                }
                //peB
                switch (cmv.RscParity)
                {
                    case Def.PARITY_NONE:
                        cmbRscParity.SelectedIndex = 0;
                        break;
                    case Def.PARITY_ODD:
                        cmbRscParity.SelectedIndex = 1;
                        break;
                    case Def.PARITY_EVEN:
                        cmbRscParity.SelectedIndex = 2;
                        break;
                }

                //********** LAN̐ڑl̏ݒ@**********
                string[] strDivIp = new string[4];
                
                //IPAhX
                string strIpAddress = cmv.LanIp;
                strDivIp = divIPAdress(strIpAddress);
                ////IPAhXi[
                txtLanIpA.Text = strDivIp[0];
                txtLanIpB.Text = strDivIp[1];
                txtLanIpC.Text = strDivIp[2];
                txtLanIpD.Text = strDivIp[3];
                //|[g
                txtLanPort.Text = Convert.ToString(cmv.LanPort);
            }
        }


        /********************
         * L[{[h̗L
         ********************/

        /// <summary>
        /// j[{^
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void mniMain_Click(object sender, EventArgs e)
        {
            // Cʂ
            this.Close();
        }

        /// <summary>
        /// I{^
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void mniEnd_Click(object sender, EventArgs e)
        {
            Application.Exit();
        }

        /// <summary>
        /// ۑ{^
        /// </summary>
        /// <param name="sender"></param>
        /// <param name="e"></param>
        private void mniSave_Click(object sender, EventArgs e)
        {

            //ۑNX(ConnectionMethodValue)̃CX^X쐬
            ConnectionMethodValue cmv = new ConnectionMethodValue();

            //********** v^ڑ@̐ݒ@**********
            //IĂli[
            switch(cmbSelect.SelectedIndex)
            {
                case 0 :
                    cmv.Connect = WindowsApplication1.Constant.PT_CONNECT_RS232C;
                    break;
                case 1 :
                    cmv.Connect = WindowsApplication1.Constant.PT_CONNECT_LAN;
                    break;
            }

            //********** RS232C̐ڑl̐ݒ@**********
            setRs232cValue(cmv);

            //********** LAN̐ڑl̐ݒ@**********
            setLANValue(cmv);

            //********** ۑ̃t@C擾@**********
            string fullAppName = Assembly.GetExecutingAssembly().GetName().CodeBase;
            string fullAppPath = Path.GetDirectoryName(fullAppName);
            string fileName = fullAppPath + @"\ConnectionMethodValue.xml";

            //XmlSerializerIuWFNg쐬
            //ރIuWFNǧ^w肷
            System.Xml.Serialization.XmlSerializer serializer =
                new System.Xml.Serialization.XmlSerializer(typeof(ConnectionMethodValue));

            //t@CJ

            System.IO.FileStream fs =
                new System.IO.FileStream(fileName,System.IO.FileMode.Create);

            //VAAXMLt@Cɕۑ
            serializer.Serialize(fs, cmv);

            //
            fs.Close();

            //bZ[W\
            MessageBox.Show("ݒ̕ۑ܂B");
        }

        /// <summary>
        /// RS232C̐ڑl̐ݒsB
        /// </summary>
        /// <param name="cmv">Rs232cpp[^ݒp</param>
        private void setRs232cValue(ConnectionMethodValue cmv)
        {
            //|[g
            cmv.RscPort = Convert.ToString(cmbRscPort.SelectedItem);

            //{[[g
            switch (cmbRscBaudrate.SelectedIndex)
            {
                case 0:
                    cmv.RscBaudrate = Def.BAUDRATE_9600;
                    break;
                case 1:
                    cmv.RscBaudrate = Def.BAUDRATE_19200;
                    break;
                case 2:
                    cmv.RscBaudrate = Def.BAUDRATE_38400;
                    break;
                case 3:
                    cmv.RscBaudrate = Def.BAUDRATE_57600;
                    break;
                case 4:
                    cmv.RscBaudrate = Def.BAUDRATE_115200;
                    break;
            }

            //peB
            switch (cmbRscParity.SelectedIndex)
            {
                case 0:
                    cmv.RscParity = Def.PARITY_NONE;
                    break;
                case 1:
                    cmv.RscParity = Def.PARITY_ODD;
                    break;
                case 2:
                    cmv.RscParity = Def.PARITY_EVEN;
                    break;
            }

        }

        /// <summary>
        /// LAN̐ڑl̐ݒsB
        /// </summary>
        /// <param name="cmv">LANpp[^ݒp</param>
        private void setLANValue(ConnectionMethodValue cmv)
        {
            //IPAhX
            cmv.LanIp = txtLanIpA.Text + "." + txtLanIpB.Text + "." +
            txtLanIpC.Text + "." + txtLanIpD.Text;

            //|[g
            if (txtLanPort.Text != String.Empty)
            {
                cmv.LanPort = Convert.ToInt16(txtLanPort.Text);
            }
        }
        /// <summary>
        /// IPAhX4
        /// </summary>
        /// <param name="strIPAddress">IPAhX</param>
        /// <returns>
        /// !NULL:
        /// </returns>
        private string[] divIPAdress(string strIPAddress)
        {
            int intIndex = 0;
            int intCnt = 0;
            string[] strValue= new string[4]; 

            //IPAhXu.v擾
            while (intCnt <= 3)
            {
                //u.v̈ʒu
                intIndex = strIPAddress.IndexOf(".");

                //u.v̐擪ɑ݂ꍇ͓ǂݔ΂
                if (intIndex == 0)
                {
                    strValue[intCnt] = "";
                }
                else
                {
                    //4ڂ̏ꍇ͕̂܂܊i[
                    if (intCnt == 3)
                    {
                        strValue[intCnt] = strIPAddress;
                    }
                    else
                    {
                        strValue[intCnt] = strIPAddress.Substring(0, intIndex);
                    }
                }

                //zɊi[͏
                strIPAddress = strIPAddress.Substring(intIndex + 1);

                //JEgAbv
                intCnt = intCnt + 1;
            }
            return strValue;
        }


        private void cmbSelect_SelectedIndexChanged(object sender, EventArgs e)
        {
            pnlRs232c.Visible = false ;
            pnlLan.Visible = false;

            switch( cmbSelect.SelectedIndex)
            {
                case 0:
                    pnlRs232c.Visible = true;
                    break;
                case 1:
                    pnlLan.Visible = true;
                    break;
            }

        }


    }
}