using System;
using System.Collections.Generic;
using System.Text;
using System.IO;
using System.Reflection;
using System.Diagnostics;

namespace sato.pt
{
    /// <summary>
    /// IȋʃNX
    /// </summary>
    class Common
    {
        #region 萔
        /***************
         * R[h
         ***************/
        /// <summary> ENQ(Xe[^XvR}h)</summary>
        public const byte ENQ = 0x05;
        /// <summary> ACK</summary>
        public const byte ACK = 0x06;
        /// <summary> NAK</summary>
        public const byte NAK = 0x15;
        /// <summary> CAN(LZR}h)</summary>
        public const byte CAN = 0x18;
        /// <summary> STX</summary>
        public const byte STX = 0x02;
        /// <summary> ETX</summary>
        public const byte ETX = 0x03;
        /// <summary> ESC</summary>
        public const byte ESC = 0x1B;

        /***************
         * Xe[^X
        ***************/

        /// <summary> ME</summary>
        public const int STR_OK = 0;
        /// <summary> ҋ@</summary>
        public const int STR_STANDBY = -1;
        /// <summary> CjV</summary>
        public const int STR_INITIAL = -2;
        /// <summary> ʉߒ</summary>
        public const int STR_WAIT_PASS = -3;
        /// <summary> \(ItC)</summary>
        public const int STR_OFF_LINE = -21;
        ///  <summary> \(wbhI[v)</summary>
        public const int STR_HEAD_OPEN = -22;
        /// <summary> \(y[p[Gh)</summary>
        public const int STR_PAPER_END = -23;
        /// <summary> \({Gh)</summary>
        public const int STR_RIBON_END = -24;
        /// <summary> \(ZTG[)</summary>
        public const int STR_SENSOR_ERROR = -25;
        /// <summary> \(Jo[I[v)</summary>
        public const int STR_COVER_OPENING = -26;
        /// <summary> s</summary>
        public const int STR_NOT_POS_RES = -99;

        /***************
         * ̑
        ***************/
        /// <summary> Xe[^Xʒu</summary>
        public const int STR_INDEX = 3;
        #endregion

        #region ʊ֐
        /// <summary>
        /// dlluĂꏊɃOo͂
        /// </summary>
        /// <param name="prmStrClassName">NX</param>
        /// <param name="prmStrMethodName">\bh</param>
        /// <param name="prmStrlogMsg">ObZ[W</param>
        public static void outputLog(string prmStrClassName, string prmStrMethodName, string prmStrlogMsg)
        {
            StreamWriter sw = null;
            try
            {
                // t@CI[v
                sw = new System.IO.StreamWriter(getAppPath() + @"\satopt.log",
                     true,
                     System.Text.Encoding.GetEncoding(932));
                // Oo
                sw.WriteLine(DateTime.Now.ToString("G") + ":" + prmStrClassName + "\t" + prmStrMethodName + "\t" + prmStrlogMsg + "\n");
            }
            finally
            {
                if (sw != null)
                    sw.Close();
            }
        }

        /// <summary>
        /// dlluĂꏊɃOo͂
        /// </summary>
        /// <param name="prmStrClassName">NX</param>
        /// <param name="prmStrMethodName">\bh</param>
        /// <param name="prmStrlogMsg">ObZ[W</param>
        [Conditional("DEBUG")]
        public static void outputDebugLog(string prmStrClassName, string prmStrMethodName, string prmStrlogMsg)
        {
            outputLog(prmStrClassName, prmStrMethodName, "[fobN]\t" + prmStrlogMsg);
        }

        /// <summary>
        /// MmF
        /// </summary>
        /// <param name="prmBytStatus">`FbNXe[^X</param>
        /// <returns>
        /// STR_OKFM
        /// STR_STANDBYFҋ@
        /// STR_WAIT_PASSFʉߑ҂
        /// STR_OFF_LINEF\(ItC)
        /// STR_HEAD_OPENF\(wbhI[v)
        /// STR_PAPER_ENDF\(y[p[Gh)
        /// STR_RIBON_ENDF\({Gh)
        /// STR_SENSOR_ERRORF\(ZTG[)
        /// STR_COVER_OPENINGF\(Jo[I[v)
        /// STR_NOT_POS_RESFs
        /// </returns>
        public static int chkPrintTransmissionCondition(byte prmBytStatus)
        {
            int intRet = STR_NOT_POS_RES;

            switch (prmBytStatus)
            {
                //CjV
                case 0x2A:
                    intRet = STR_INITIAL;
                    break;
                /******************
                 * ItC
                 ******************/
                case 0x30:  // G[Ȃ
                case 0x31:  // {Ex  jAGh
                case 0x32:  // obt@jAt
                case 0x33:  // {Ex  jAGhobt@jAt
                    intRet = STR_OFF_LINE;   // \ȃG[/ItC
                    break;
                /******************
                 * IC
                 ******************/
                // M҂
                case 0x41:  // G[Ȃ
                case 0x42:  // {Ex  jAGh
                    intRet = STR_OK;   // M
                    break;
                case 0x43:  // obt@jAt
                case 0x44:  // {Ex  jAGhobt@jAt
                // 󎚒
                case 0x47:  // G[Ȃ
                case 0x48:  // {Ex  jAGh
                case 0x49:  // obt@jAt
                case 0x4A:  // {Ex  jAGhobt@jAt
                // 󎚑҂Eʉߑ҂
                case 0x4D:  // G[Ȃ
                case 0x4E:  // {Ex  jAGh
                case 0x4F:  // obt@jAt
                case 0x50:  // {Ex  jAGhobt@jAt
                // ́EҏW
                case 0x53:  // G[Ȃ
                case 0x54:  // {Ex  jAGh
                case 0x55:  // obt@jAt
                case 0x56:  // {Ex  jAGhobt@jAt
                // 󎚋zNM҂^\t
                case 0x6F:  // G[Ȃ
                case 0x70:  // {Ex  jAGh
                case 0x71:  // obt@jAt
                case 0x72:  // {Ex  jAGhobt@jAt
                    intRet = STR_STANDBY;   // ҋ@
                    break;
                // ʉߒ
                case 0x73:  // G[Ȃ
                case 0x74:  // {Ex  jAGh
                case 0x75:  // obt@jAt
                case 0x76:  // {Ex  jAGhobt@jAt
                    intRet = STR_WAIT_PASS;  // ʉߑ҂
                    break;
                /*****************************
                 * G[o(ItC)
                 *****************************/
                case 0x61:  // obt@I[o[
                    intRet = STR_NOT_POS_RES;   // s
                    break;
                case 0x62:  // wbhI[v
                    intRet = STR_HEAD_OPEN;
                    break;
                case 0x63:  // y[p[GhEZT[G[Epl܂G[
                    intRet = STR_PAPER_END;     // \ȃG[
                    break;
                case 0x64:  // {Gh
                    intRet = STR_RIBON_END;     // \ȃG[
                    break;
                case 0x67:  // wbhG[
                    intRet = STR_NOT_POS_RES;   // s
                    break;
                case 0x68:  // Jo[I[v
                    intRet = STR_COVER_OPENING; // \ȃG[
                    break;
                case 0x69:  // J[hG[
                case 0x6B:  // ̑̃G[
                case 0x6C:  // x\tG[

                case 0x23:  // xzG[
                case 0x24:  // \̓I[o[G[
                case 0x25:  // V_sǃG[
                case 0x2B:  // [U[p̃G[
                    intRet = STR_NOT_POS_RES;   // s
                    break;
            }

            return intRet;
        }

        /// <summary>
        /// mF
        /// </summary>
        /// <param name="prmBytStatus">`FbNXe[^X</param>
        /// <returns>
        /// STR_OKF
        /// STR_STANDBYFҋ@
        /// STR_WAIT_PASSFʉߑ҂
        /// STR_OFF_LINEF\(ItC)
        /// STR_HEAD_OPENF\(wbhI[v)
        /// STR_PAPER_ENDF\(y[p[Gh)
        /// STR_RIBON_ENDF\({Gh)
        /// STR_SENSOR_ERRORF\(ZTG[)
        /// STR_COVER_OPENINGF\(Jo[I[v)
        /// STR_NOT_POS_RESFs
        /// </returns>
        public static int chkPrintCompletionCondition(byte prmBytStatus)
        {
            int intRet = STR_NOT_POS_RES;

            switch (prmBytStatus)
            {
                //CjV
                case 0x2A:
                    intRet = STR_INITIAL;
                    break;
                /******************
                 * ItC
                 ******************/
                case 0x30:  // G[Ȃ
                case 0x31:  // {Ex  jAGh
                case 0x32:  // obt@jAt
                case 0x33:  // {Ex  jAGhobt@jAt
                    intRet = STR_OFF_LINE;   // \ȃG[/ItC
                    break;
                /******************
                  * IC
                 ******************/
                // M҂
                case 0x41:  // G[Ȃ
                case 0x42:  // {Ex  jAGh
                case 0x43:  // obt@jAt
                case 0x44:  // {Ex  jAGhobt@jAt
                    intRet = STR_OK;   // M
                    break;
                // 󎚒
                case 0x47:  // G[Ȃ
                case 0x48:  // {Ex  jAGh
                case 0x49:  // obt@jAt
                case 0x4A:  // {Ex  jAGhobt@jAt
                // 󎚑҂Eʉߑ҂
                case 0x4D:  // G[Ȃ
                case 0x4E:  // {Ex  jAGh
                case 0x4F:  // obt@jAt
                case 0x50:  // {Ex  jAGhobt@jAt
                // ́EҏW
                case 0x53:  // G[Ȃ
                case 0x54:  // {Ex  jAGh
                case 0x55:  // obt@jAt
                case 0x56:  // {Ex  jAGhobt@jAt

                // 󎚋zNM҂^\t
                case 0x6F:  // G[Ȃ
                case 0x70:  // {Ex  jAGh
                case 0x71:  // obt@jAt
                case 0x72:  // {Ex  jAGhobt@jAt

                    intRet = STR_STANDBY;   // ҋ@
                    break;

                // ʉߒ
                case 0x73:  // G[Ȃ
                case 0x74:  // {Ex  jAGh
                case 0x75:  // obt@jAt
                case 0x76:  // {Ex  jAGhobt@jAt
                    intRet = STR_WAIT_PASS;  // ʉߑ҂
                    break;
                /*****************************
                 * G[o(ItC)
                 *****************************/
                case 0x61:  // obt@I[o[
                    intRet = STR_NOT_POS_RES;   // s
                    break;
                case 0x62:  // wbhI[v
                    intRet = STR_HEAD_OPEN;
                    break;
                case 0x63:  // y[p[GhEZT[G[Epl܂G[
                    intRet = STR_PAPER_END;     // \ȃG[
                    break;
                case 0x64:  // {Gh
                    intRet = STR_RIBON_END;     // \ȃG[
                    break;
                case 0x67:  // wbhG[
                    intRet = STR_NOT_POS_RES;   // s
                    break;
                case 0x68:  // Jo[I[v
                    intRet = STR_COVER_OPENING; // \ȃG[
                    break;
                case 0x69:  // J[hG[
                case 0x6B:  // ̑̃G[
                case 0x6C:  // x\tG[

                case 0x23:  // xzG[
                case 0x24:  // \̓I[o[G[
                case 0x25:  // V_sǃG[
                case 0x2B:  // [U[p̃G[
                    intRet = STR_NOT_POS_RES;   // s
                    break;
            }

            return intRet;
        }

        /// <summary>
        /// pXԂ
        /// </summary>
        /// <returns>
        /// pX
        /// </returns>
        public static string getAppPath()
        {
            string strAppName;     //exe܂ރAvP[ṼpX
            string strAppPath;     //exe菜AvP[ṼpX

            //AvP[ṼtpX擾
            strAppName = Assembly.GetExecutingAssembly().Location;
            //exe菜
            strAppPath = Path.GetDirectoryName(strAppName);

            //pX߂lƂĕԂ
            return strAppPath;
        }
        #endregion
    }
}
